theory speed
imports counter
begin


type_synonym speed_inputs = "Bool \<times> Bool"

type_synonym speed_outputs = "Bool \<times> Bool"

type_synonym speed_state = "Integer \<times> Integer"



fun   speed_block::"(speed_inputs stream \<times> speed_state stream \<times> speed_outputs stream) \<Rightarrow> 
                    (speed_state stream \<times> speed_outputs stream)" 
where"speed_block (inp,st,out) = 
(let \<lbrakk>diff, incr\<rbrakk>     = st;
     \<lbrakk>beacon, second\<rbrakk> = inp;
     \<lbrakk>late, early\<rbrakk>    = out;
     incr'           = if beacon and not second 
                       then 1 
                       else if second and not beacon 
                            then -1 
                            else 0 
                            endif 
                       endif;
     diff'           = COUNTER (0, incr', beacon or second, false);
     st'             = \<lbrakk>diff', incr'\<rbrakk>;
     early'          = false -> (if early then diff' >s 0 else diff' >=s 10 endif);
     late'           = false -> (if late  then diff' <s 0 else diff' <=s -10 endif);
     out'            = \<lbrakk>late', early'\<rbrakk>
in  (st', out'))" 


definition speed :: "Bool stream \<times> Bool stream \<Rightarrow> Bool stream \<times> Bool stream"
where     "speed = (\<lambda>(beacon, second). let \<lbrakk>late, early\<rbrakk> = loop speed_block \<lbrakk>beacon, second\<rbrakk> 
                                       in (late, early))"




end
